#ifndef _SCGENMOD_fifo_gen_
#define _SCGENMOD_fifo_gen_

#include "systemc.h"

class fifo_gen : public sc_foreign_module
{
public:
    sc_in<bool> p_clk;
    sc_in<bool> p_resetn;
    sc_out<bool> p_w;
    sc_in<bool> p_wok;
    sc_out<sc_uint<8> > p_data;


    fifo_gen(sc_module_name nm, const char* hdl_name)
     : sc_foreign_module(nm),
       p_clk("p_clk"),
       p_resetn("p_resetn"),
       p_w("p_w"),
       p_wok("p_wok"),
       p_data("p_data")
    {
        elaborate_foreign_module(hdl_name);
    }
    ~fifo_gen()
    {}

};

#endif

